-- ==============================================================
-- RTL generated by Vivado(TM) HLS - High-Level Synthesis from C, C++ and OpenCL
-- Version: 2020.1
-- Copyright (C) 1986-2020 Xilinx, Inc. All Rights Reserved.
-- 
-- ===========================================================

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity resize_accel is
generic (
    C_S_AXI_AXILITES_ADDR_WIDTH : INTEGER := 6;
    C_S_AXI_AXILITES_DATA_WIDTH : INTEGER := 32 );
port (
    s_axi_AXILiteS_AWVALID : IN STD_LOGIC;
    s_axi_AXILiteS_AWREADY : OUT STD_LOGIC;
    s_axi_AXILiteS_AWADDR : IN STD_LOGIC_VECTOR (C_S_AXI_AXILITES_ADDR_WIDTH-1 downto 0);
    s_axi_AXILiteS_WVALID : IN STD_LOGIC;
    s_axi_AXILiteS_WREADY : OUT STD_LOGIC;
    s_axi_AXILiteS_WDATA : IN STD_LOGIC_VECTOR (C_S_AXI_AXILITES_DATA_WIDTH-1 downto 0);
    s_axi_AXILiteS_WSTRB : IN STD_LOGIC_VECTOR (C_S_AXI_AXILITES_DATA_WIDTH/8-1 downto 0);
    s_axi_AXILiteS_ARVALID : IN STD_LOGIC;
    s_axi_AXILiteS_ARREADY : OUT STD_LOGIC;
    s_axi_AXILiteS_ARADDR : IN STD_LOGIC_VECTOR (C_S_AXI_AXILITES_ADDR_WIDTH-1 downto 0);
    s_axi_AXILiteS_RVALID : OUT STD_LOGIC;
    s_axi_AXILiteS_RREADY : IN STD_LOGIC;
    s_axi_AXILiteS_RDATA : OUT STD_LOGIC_VECTOR (C_S_AXI_AXILITES_DATA_WIDTH-1 downto 0);
    s_axi_AXILiteS_RRESP : OUT STD_LOGIC_VECTOR (1 downto 0);
    s_axi_AXILiteS_BVALID : OUT STD_LOGIC;
    s_axi_AXILiteS_BREADY : IN STD_LOGIC;
    s_axi_AXILiteS_BRESP : OUT STD_LOGIC_VECTOR (1 downto 0);
    ap_clk : IN STD_LOGIC;
    ap_rst_n : IN STD_LOGIC;
    interrupt : OUT STD_LOGIC;
    srcPtr_TDATA : IN STD_LOGIC_VECTOR (23 downto 0);
    srcPtr_TKEEP : IN STD_LOGIC_VECTOR (2 downto 0);
    srcPtr_TSTRB : IN STD_LOGIC_VECTOR (2 downto 0);
    srcPtr_TUSER : IN STD_LOGIC_VECTOR (0 downto 0);
    srcPtr_TLAST : IN STD_LOGIC_VECTOR (0 downto 0);
    srcPtr_TID : IN STD_LOGIC_VECTOR (0 downto 0);
    srcPtr_TDEST : IN STD_LOGIC_VECTOR (0 downto 0);
    dstPtr_TDATA : OUT STD_LOGIC_VECTOR (23 downto 0);
    dstPtr_TKEEP : OUT STD_LOGIC_VECTOR (2 downto 0);
    dstPtr_TSTRB : OUT STD_LOGIC_VECTOR (2 downto 0);
    dstPtr_TUSER : OUT STD_LOGIC_VECTOR (0 downto 0);
    dstPtr_TLAST : OUT STD_LOGIC_VECTOR (0 downto 0);
    dstPtr_TID : OUT STD_LOGIC_VECTOR (0 downto 0);
    dstPtr_TDEST : OUT STD_LOGIC_VECTOR (0 downto 0);
    srcPtr_TVALID : IN STD_LOGIC;
    srcPtr_TREADY : OUT STD_LOGIC;
    dstPtr_TVALID : OUT STD_LOGIC;
    dstPtr_TREADY : IN STD_LOGIC );
end;


architecture behav of resize_accel is 
    attribute CORE_GENERATION_INFO : STRING;
    attribute CORE_GENERATION_INFO of behav : architecture is
    "resize_accel,hls_ip_2020_1,{HLS_INPUT_TYPE=cxx,HLS_INPUT_FLOAT=0,HLS_INPUT_FIXED=0,HLS_INPUT_PART=xc7z020-clg484-1,HLS_INPUT_CLOCK=3.300000,HLS_INPUT_ARCH=dataflow,HLS_SYN_CLOCK=4.336000,HLS_SYN_LAT=-1,HLS_SYN_TPT=-1,HLS_SYN_MEM=3,HLS_SYN_DSP=19,HLS_SYN_FF=12047,HLS_SYN_LUT=11440,HLS_VERSION=2020_1}";
    constant C_S_AXI_DATA_WIDTH : INTEGER range 63 downto 0 := 20;
    constant C_S_AXI_WSTRB_WIDTH : INTEGER range 63 downto 0 := 4;
    constant C_S_AXI_ADDR_WIDTH : INTEGER range 63 downto 0 := 20;
    constant ap_const_logic_1 : STD_LOGIC := '1';
    constant ap_const_lv24_0 : STD_LOGIC_VECTOR (23 downto 0) := "000000000000000000000000";
    constant ap_const_lv3_0 : STD_LOGIC_VECTOR (2 downto 0) := "000";
    constant ap_const_lv1_0 : STD_LOGIC_VECTOR (0 downto 0) := "0";
    constant ap_const_logic_0 : STD_LOGIC := '0';
    constant ap_const_lv2_0 : STD_LOGIC_VECTOR (1 downto 0) := "00";
    constant ap_const_lv2_1 : STD_LOGIC_VECTOR (1 downto 0) := "01";
    constant ap_const_boolean_1 : BOOLEAN := true;

    signal ap_rst_n_inv : STD_LOGIC;
    signal ap_start : STD_LOGIC;
    signal ap_ready : STD_LOGIC;
    signal ap_done : STD_LOGIC;
    signal ap_idle : STD_LOGIC;
    signal rows_in : STD_LOGIC_VECTOR (31 downto 0);
    signal cols_in : STD_LOGIC_VECTOR (31 downto 0);
    signal rows_out : STD_LOGIC_VECTOR (31 downto 0);
    signal cols_out : STD_LOGIC_VECTOR (31 downto 0);
    signal Block_Mat_exit7_proc_U0_ap_start : STD_LOGIC;
    signal Block_Mat_exit7_proc_U0_ap_done : STD_LOGIC;
    signal Block_Mat_exit7_proc_U0_ap_continue : STD_LOGIC;
    signal Block_Mat_exit7_proc_U0_ap_idle : STD_LOGIC;
    signal Block_Mat_exit7_proc_U0_ap_ready : STD_LOGIC;
    signal Block_Mat_exit7_proc_U0_start_out : STD_LOGIC;
    signal Block_Mat_exit7_proc_U0_start_write : STD_LOGIC;
    signal Block_Mat_exit7_proc_U0_in_mat_rows_out_din : STD_LOGIC_VECTOR (31 downto 0);
    signal Block_Mat_exit7_proc_U0_in_mat_rows_out_write : STD_LOGIC;
    signal Block_Mat_exit7_proc_U0_in_mat_cols_out_din : STD_LOGIC_VECTOR (31 downto 0);
    signal Block_Mat_exit7_proc_U0_in_mat_cols_out_write : STD_LOGIC;
    signal Block_Mat_exit7_proc_U0_out_mat_rows_out_din : STD_LOGIC_VECTOR (31 downto 0);
    signal Block_Mat_exit7_proc_U0_out_mat_rows_out_write : STD_LOGIC;
    signal Block_Mat_exit7_proc_U0_out_mat_cols_out_din : STD_LOGIC_VECTOR (31 downto 0);
    signal Block_Mat_exit7_proc_U0_out_mat_cols_out_write : STD_LOGIC;
    signal AXIvideo2xfMat_U0_ap_start : STD_LOGIC;
    signal AXIvideo2xfMat_U0_ap_done : STD_LOGIC;
    signal AXIvideo2xfMat_U0_ap_continue : STD_LOGIC;
    signal AXIvideo2xfMat_U0_ap_idle : STD_LOGIC;
    signal AXIvideo2xfMat_U0_ap_ready : STD_LOGIC;
    signal AXIvideo2xfMat_U0_srcPtr_TREADY : STD_LOGIC;
    signal AXIvideo2xfMat_U0_img_rows_read : STD_LOGIC;
    signal AXIvideo2xfMat_U0_img_cols_read : STD_LOGIC;
    signal AXIvideo2xfMat_U0_img_data_V_V_din : STD_LOGIC_VECTOR (23 downto 0);
    signal AXIvideo2xfMat_U0_img_data_V_V_write : STD_LOGIC;
    signal AXIvideo2xfMat_U0_img_rows_out_din : STD_LOGIC_VECTOR (31 downto 0);
    signal AXIvideo2xfMat_U0_img_rows_out_write : STD_LOGIC;
    signal AXIvideo2xfMat_U0_img_cols_out_din : STD_LOGIC_VECTOR (31 downto 0);
    signal AXIvideo2xfMat_U0_img_cols_out_write : STD_LOGIC;
    signal resize_U0_ap_start : STD_LOGIC;
    signal resize_U0_ap_done : STD_LOGIC;
    signal resize_U0_ap_continue : STD_LOGIC;
    signal resize_U0_ap_idle : STD_LOGIC;
    signal resize_U0_ap_ready : STD_LOGIC;
    signal resize_U0_start_out : STD_LOGIC;
    signal resize_U0_start_write : STD_LOGIC;
    signal resize_U0_p_src_rows_read : STD_LOGIC;
    signal resize_U0_p_src_cols_read : STD_LOGIC;
    signal resize_U0_p_src_data_V_V_read : STD_LOGIC;
    signal resize_U0_p_dst_rows_read : STD_LOGIC;
    signal resize_U0_p_dst_cols_read : STD_LOGIC;
    signal resize_U0_p_dst_data_V_V_din : STD_LOGIC_VECTOR (23 downto 0);
    signal resize_U0_p_dst_data_V_V_write : STD_LOGIC;
    signal resize_U0_p_dst_rows_out_din : STD_LOGIC_VECTOR (31 downto 0);
    signal resize_U0_p_dst_rows_out_write : STD_LOGIC;
    signal resize_U0_p_dst_cols_out_din : STD_LOGIC_VECTOR (31 downto 0);
    signal resize_U0_p_dst_cols_out_write : STD_LOGIC;
    signal xfMat2AXIvideo_U0_ap_start : STD_LOGIC;
    signal xfMat2AXIvideo_U0_ap_done : STD_LOGIC;
    signal xfMat2AXIvideo_U0_ap_continue : STD_LOGIC;
    signal xfMat2AXIvideo_U0_ap_idle : STD_LOGIC;
    signal xfMat2AXIvideo_U0_ap_ready : STD_LOGIC;
    signal xfMat2AXIvideo_U0_img_rows_read : STD_LOGIC;
    signal xfMat2AXIvideo_U0_img_cols_read : STD_LOGIC;
    signal xfMat2AXIvideo_U0_img_data_V_V_read : STD_LOGIC;
    signal xfMat2AXIvideo_U0_dstPtr_TDATA : STD_LOGIC_VECTOR (23 downto 0);
    signal xfMat2AXIvideo_U0_dstPtr_TVALID : STD_LOGIC;
    signal xfMat2AXIvideo_U0_dstPtr_TKEEP : STD_LOGIC_VECTOR (2 downto 0);
    signal xfMat2AXIvideo_U0_dstPtr_TSTRB : STD_LOGIC_VECTOR (2 downto 0);
    signal xfMat2AXIvideo_U0_dstPtr_TUSER : STD_LOGIC_VECTOR (0 downto 0);
    signal xfMat2AXIvideo_U0_dstPtr_TLAST : STD_LOGIC_VECTOR (0 downto 0);
    signal xfMat2AXIvideo_U0_dstPtr_TID : STD_LOGIC_VECTOR (0 downto 0);
    signal xfMat2AXIvideo_U0_dstPtr_TDEST : STD_LOGIC_VECTOR (0 downto 0);
    signal ap_sync_continue : STD_LOGIC;
    signal in_mat_rows_c_full_n : STD_LOGIC;
    signal in_mat_rows_c_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal in_mat_rows_c_empty_n : STD_LOGIC;
    signal in_mat_cols_c_full_n : STD_LOGIC;
    signal in_mat_cols_c_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal in_mat_cols_c_empty_n : STD_LOGIC;
    signal out_mat_rows_c_full_n : STD_LOGIC;
    signal out_mat_rows_c_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal out_mat_rows_c_empty_n : STD_LOGIC;
    signal out_mat_cols_c_full_n : STD_LOGIC;
    signal out_mat_cols_c_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal out_mat_cols_c_empty_n : STD_LOGIC;
    signal in_mat_data_V_V_full_n : STD_LOGIC;
    signal in_mat_data_V_V_dout : STD_LOGIC_VECTOR (23 downto 0);
    signal in_mat_data_V_V_empty_n : STD_LOGIC;
    signal in_mat_rows_c15_full_n : STD_LOGIC;
    signal in_mat_rows_c15_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal in_mat_rows_c15_empty_n : STD_LOGIC;
    signal in_mat_cols_c16_full_n : STD_LOGIC;
    signal in_mat_cols_c16_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal in_mat_cols_c16_empty_n : STD_LOGIC;
    signal out_mat_data_V_V_full_n : STD_LOGIC;
    signal out_mat_data_V_V_dout : STD_LOGIC_VECTOR (23 downto 0);
    signal out_mat_data_V_V_empty_n : STD_LOGIC;
    signal out_mat_rows_c17_full_n : STD_LOGIC;
    signal out_mat_rows_c17_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal out_mat_rows_c17_empty_n : STD_LOGIC;
    signal out_mat_cols_c18_full_n : STD_LOGIC;
    signal out_mat_cols_c18_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal out_mat_cols_c18_empty_n : STD_LOGIC;
    signal ap_sync_done : STD_LOGIC;
    signal ap_sync_ready : STD_LOGIC;
    signal ap_sync_reg_Block_Mat_exit7_proc_U0_ap_ready : STD_LOGIC := '0';
    signal ap_sync_Block_Mat_exit7_proc_U0_ap_ready : STD_LOGIC;
    signal Block_Mat_exit7_proc_U0_ap_ready_count : STD_LOGIC_VECTOR (1 downto 0) := "00";
    signal ap_sync_reg_AXIvideo2xfMat_U0_ap_ready : STD_LOGIC := '0';
    signal ap_sync_AXIvideo2xfMat_U0_ap_ready : STD_LOGIC;
    signal AXIvideo2xfMat_U0_ap_ready_count : STD_LOGIC_VECTOR (1 downto 0) := "00";
    signal start_for_resize_U0_din : STD_LOGIC_VECTOR (0 downto 0);
    signal start_for_resize_U0_full_n : STD_LOGIC;
    signal start_for_resize_U0_dout : STD_LOGIC_VECTOR (0 downto 0);
    signal start_for_resize_U0_empty_n : STD_LOGIC;
    signal AXIvideo2xfMat_U0_start_full_n : STD_LOGIC;
    signal AXIvideo2xfMat_U0_start_write : STD_LOGIC;
    signal start_for_xfMat2AXIvideo_U0_din : STD_LOGIC_VECTOR (0 downto 0);
    signal start_for_xfMat2AXIvideo_U0_full_n : STD_LOGIC;
    signal start_for_xfMat2AXIvideo_U0_dout : STD_LOGIC_VECTOR (0 downto 0);
    signal start_for_xfMat2AXIvideo_U0_empty_n : STD_LOGIC;
    signal xfMat2AXIvideo_U0_start_full_n : STD_LOGIC;
    signal xfMat2AXIvideo_U0_start_write : STD_LOGIC;

    component Block_Mat_exit7_proc IS
    port (
        ap_clk : IN STD_LOGIC;
        ap_rst : IN STD_LOGIC;
        ap_start : IN STD_LOGIC;
        start_full_n : IN STD_LOGIC;
        ap_done : OUT STD_LOGIC;
        ap_continue : IN STD_LOGIC;
        ap_idle : OUT STD_LOGIC;
        ap_ready : OUT STD_LOGIC;
        start_out : OUT STD_LOGIC;
        start_write : OUT STD_LOGIC;
        rows_in : IN STD_LOGIC_VECTOR (31 downto 0);
        cols_in : IN STD_LOGIC_VECTOR (31 downto 0);
        rows_out : IN STD_LOGIC_VECTOR (31 downto 0);
        cols_out : IN STD_LOGIC_VECTOR (31 downto 0);
        in_mat_rows_out_din : OUT STD_LOGIC_VECTOR (31 downto 0);
        in_mat_rows_out_full_n : IN STD_LOGIC;
        in_mat_rows_out_write : OUT STD_LOGIC;
        in_mat_cols_out_din : OUT STD_LOGIC_VECTOR (31 downto 0);
        in_mat_cols_out_full_n : IN STD_LOGIC;
        in_mat_cols_out_write : OUT STD_LOGIC;
        out_mat_rows_out_din : OUT STD_LOGIC_VECTOR (31 downto 0);
        out_mat_rows_out_full_n : IN STD_LOGIC;
        out_mat_rows_out_write : OUT STD_LOGIC;
        out_mat_cols_out_din : OUT STD_LOGIC_VECTOR (31 downto 0);
        out_mat_cols_out_full_n : IN STD_LOGIC;
        out_mat_cols_out_write : OUT STD_LOGIC );
    end component;


    component AXIvideo2xfMat IS
    port (
        ap_clk : IN STD_LOGIC;
        ap_rst : IN STD_LOGIC;
        ap_start : IN STD_LOGIC;
        ap_done : OUT STD_LOGIC;
        ap_continue : IN STD_LOGIC;
        ap_idle : OUT STD_LOGIC;
        ap_ready : OUT STD_LOGIC;
        srcPtr_TDATA : IN STD_LOGIC_VECTOR (23 downto 0);
        srcPtr_TVALID : IN STD_LOGIC;
        srcPtr_TREADY : OUT STD_LOGIC;
        srcPtr_TKEEP : IN STD_LOGIC_VECTOR (2 downto 0);
        srcPtr_TSTRB : IN STD_LOGIC_VECTOR (2 downto 0);
        srcPtr_TUSER : IN STD_LOGIC_VECTOR (0 downto 0);
        srcPtr_TLAST : IN STD_LOGIC_VECTOR (0 downto 0);
        srcPtr_TID : IN STD_LOGIC_VECTOR (0 downto 0);
        srcPtr_TDEST : IN STD_LOGIC_VECTOR (0 downto 0);
        img_rows_dout : IN STD_LOGIC_VECTOR (31 downto 0);
        img_rows_empty_n : IN STD_LOGIC;
        img_rows_read : OUT STD_LOGIC;
        img_cols_dout : IN STD_LOGIC_VECTOR (31 downto 0);
        img_cols_empty_n : IN STD_LOGIC;
        img_cols_read : OUT STD_LOGIC;
        img_data_V_V_din : OUT STD_LOGIC_VECTOR (23 downto 0);
        img_data_V_V_full_n : IN STD_LOGIC;
        img_data_V_V_write : OUT STD_LOGIC;
        img_rows_out_din : OUT STD_LOGIC_VECTOR (31 downto 0);
        img_rows_out_full_n : IN STD_LOGIC;
        img_rows_out_write : OUT STD_LOGIC;
        img_cols_out_din : OUT STD_LOGIC_VECTOR (31 downto 0);
        img_cols_out_full_n : IN STD_LOGIC;
        img_cols_out_write : OUT STD_LOGIC );
    end component;


    component resize IS
    port (
        ap_clk : IN STD_LOGIC;
        ap_rst : IN STD_LOGIC;
        ap_start : IN STD_LOGIC;
        start_full_n : IN STD_LOGIC;
        ap_done : OUT STD_LOGIC;
        ap_continue : IN STD_LOGIC;
        ap_idle : OUT STD_LOGIC;
        ap_ready : OUT STD_LOGIC;
        start_out : OUT STD_LOGIC;
        start_write : OUT STD_LOGIC;
        p_src_rows_dout : IN STD_LOGIC_VECTOR (31 downto 0);
        p_src_rows_empty_n : IN STD_LOGIC;
        p_src_rows_read : OUT STD_LOGIC;
        p_src_cols_dout : IN STD_LOGIC_VECTOR (31 downto 0);
        p_src_cols_empty_n : IN STD_LOGIC;
        p_src_cols_read : OUT STD_LOGIC;
        p_src_data_V_V_dout : IN STD_LOGIC_VECTOR (23 downto 0);
        p_src_data_V_V_empty_n : IN STD_LOGIC;
        p_src_data_V_V_read : OUT STD_LOGIC;
        p_dst_rows_dout : IN STD_LOGIC_VECTOR (31 downto 0);
        p_dst_rows_empty_n : IN STD_LOGIC;
        p_dst_rows_read : OUT STD_LOGIC;
        p_dst_cols_dout : IN STD_LOGIC_VECTOR (31 downto 0);
        p_dst_cols_empty_n : IN STD_LOGIC;
        p_dst_cols_read : OUT STD_LOGIC;
        p_dst_data_V_V_din : OUT STD_LOGIC_VECTOR (23 downto 0);
        p_dst_data_V_V_full_n : IN STD_LOGIC;
        p_dst_data_V_V_write : OUT STD_LOGIC;
        p_dst_rows_out_din : OUT STD_LOGIC_VECTOR (31 downto 0);
        p_dst_rows_out_full_n : IN STD_LOGIC;
        p_dst_rows_out_write : OUT STD_LOGIC;
        p_dst_cols_out_din : OUT STD_LOGIC_VECTOR (31 downto 0);
        p_dst_cols_out_full_n : IN STD_LOGIC;
        p_dst_cols_out_write : OUT STD_LOGIC );
    end component;


    component xfMat2AXIvideo IS
    port (
        ap_clk : IN STD_LOGIC;
        ap_rst : IN STD_LOGIC;
        ap_start : IN STD_LOGIC;
        ap_done : OUT STD_LOGIC;
        ap_continue : IN STD_LOGIC;
        ap_idle : OUT STD_LOGIC;
        ap_ready : OUT STD_LOGIC;
        img_rows_dout : IN STD_LOGIC_VECTOR (31 downto 0);
        img_rows_empty_n : IN STD_LOGIC;
        img_rows_read : OUT STD_LOGIC;
        img_cols_dout : IN STD_LOGIC_VECTOR (31 downto 0);
        img_cols_empty_n : IN STD_LOGIC;
        img_cols_read : OUT STD_LOGIC;
        img_data_V_V_dout : IN STD_LOGIC_VECTOR (23 downto 0);
        img_data_V_V_empty_n : IN STD_LOGIC;
        img_data_V_V_read : OUT STD_LOGIC;
        dstPtr_TDATA : OUT STD_LOGIC_VECTOR (23 downto 0);
        dstPtr_TVALID : OUT STD_LOGIC;
        dstPtr_TREADY : IN STD_LOGIC;
        dstPtr_TKEEP : OUT STD_LOGIC_VECTOR (2 downto 0);
        dstPtr_TSTRB : OUT STD_LOGIC_VECTOR (2 downto 0);
        dstPtr_TUSER : OUT STD_LOGIC_VECTOR (0 downto 0);
        dstPtr_TLAST : OUT STD_LOGIC_VECTOR (0 downto 0);
        dstPtr_TID : OUT STD_LOGIC_VECTOR (0 downto 0);
        dstPtr_TDEST : OUT STD_LOGIC_VECTOR (0 downto 0) );
    end component;


    component fifo_w32_d2_A IS
    port (
        clk : IN STD_LOGIC;
        reset : IN STD_LOGIC;
        if_read_ce : IN STD_LOGIC;
        if_write_ce : IN STD_LOGIC;
        if_din : IN STD_LOGIC_VECTOR (31 downto 0);
        if_full_n : OUT STD_LOGIC;
        if_write : IN STD_LOGIC;
        if_dout : OUT STD_LOGIC_VECTOR (31 downto 0);
        if_empty_n : OUT STD_LOGIC;
        if_read : IN STD_LOGIC );
    end component;


    component fifo_w32_d3_A IS
    port (
        clk : IN STD_LOGIC;
        reset : IN STD_LOGIC;
        if_read_ce : IN STD_LOGIC;
        if_write_ce : IN STD_LOGIC;
        if_din : IN STD_LOGIC_VECTOR (31 downto 0);
        if_full_n : OUT STD_LOGIC;
        if_write : IN STD_LOGIC;
        if_dout : OUT STD_LOGIC_VECTOR (31 downto 0);
        if_empty_n : OUT STD_LOGIC;
        if_read : IN STD_LOGIC );
    end component;


    component fifo_w24_d2_A IS
    port (
        clk : IN STD_LOGIC;
        reset : IN STD_LOGIC;
        if_read_ce : IN STD_LOGIC;
        if_write_ce : IN STD_LOGIC;
        if_din : IN STD_LOGIC_VECTOR (23 downto 0);
        if_full_n : OUT STD_LOGIC;
        if_write : IN STD_LOGIC;
        if_dout : OUT STD_LOGIC_VECTOR (23 downto 0);
        if_empty_n : OUT STD_LOGIC;
        if_read : IN STD_LOGIC );
    end component;


    component start_for_resize_U0 IS
    port (
        clk : IN STD_LOGIC;
        reset : IN STD_LOGIC;
        if_read_ce : IN STD_LOGIC;
        if_write_ce : IN STD_LOGIC;
        if_din : IN STD_LOGIC_VECTOR (0 downto 0);
        if_full_n : OUT STD_LOGIC;
        if_write : IN STD_LOGIC;
        if_dout : OUT STD_LOGIC_VECTOR (0 downto 0);
        if_empty_n : OUT STD_LOGIC;
        if_read : IN STD_LOGIC );
    end component;


    component start_for_xfMat2AlbW IS
    port (
        clk : IN STD_LOGIC;
        reset : IN STD_LOGIC;
        if_read_ce : IN STD_LOGIC;
        if_write_ce : IN STD_LOGIC;
        if_din : IN STD_LOGIC_VECTOR (0 downto 0);
        if_full_n : OUT STD_LOGIC;
        if_write : IN STD_LOGIC;
        if_dout : OUT STD_LOGIC_VECTOR (0 downto 0);
        if_empty_n : OUT STD_LOGIC;
        if_read : IN STD_LOGIC );
    end component;


    component resize_accel_AXILiteS_s_axi IS
    generic (
        C_S_AXI_ADDR_WIDTH : INTEGER;
        C_S_AXI_DATA_WIDTH : INTEGER );
    port (
        AWVALID : IN STD_LOGIC;
        AWREADY : OUT STD_LOGIC;
        AWADDR : IN STD_LOGIC_VECTOR (C_S_AXI_ADDR_WIDTH-1 downto 0);
        WVALID : IN STD_LOGIC;
        WREADY : OUT STD_LOGIC;
        WDATA : IN STD_LOGIC_VECTOR (C_S_AXI_DATA_WIDTH-1 downto 0);
        WSTRB : IN STD_LOGIC_VECTOR (C_S_AXI_DATA_WIDTH/8-1 downto 0);
        ARVALID : IN STD_LOGIC;
        ARREADY : OUT STD_LOGIC;
        ARADDR : IN STD_LOGIC_VECTOR (C_S_AXI_ADDR_WIDTH-1 downto 0);
        RVALID : OUT STD_LOGIC;
        RREADY : IN STD_LOGIC;
        RDATA : OUT STD_LOGIC_VECTOR (C_S_AXI_DATA_WIDTH-1 downto 0);
        RRESP : OUT STD_LOGIC_VECTOR (1 downto 0);
        BVALID : OUT STD_LOGIC;
        BREADY : IN STD_LOGIC;
        BRESP : OUT STD_LOGIC_VECTOR (1 downto 0);
        ACLK : IN STD_LOGIC;
        ARESET : IN STD_LOGIC;
        ACLK_EN : IN STD_LOGIC;
        ap_start : OUT STD_LOGIC;
        interrupt : OUT STD_LOGIC;
        ap_ready : IN STD_LOGIC;
        ap_done : IN STD_LOGIC;
        ap_idle : IN STD_LOGIC;
        rows_in : OUT STD_LOGIC_VECTOR (31 downto 0);
        cols_in : OUT STD_LOGIC_VECTOR (31 downto 0);
        rows_out : OUT STD_LOGIC_VECTOR (31 downto 0);
        cols_out : OUT STD_LOGIC_VECTOR (31 downto 0) );
    end component;



begin
    resize_accel_AXILiteS_s_axi_U : component resize_accel_AXILiteS_s_axi
    generic map (
        C_S_AXI_ADDR_WIDTH => C_S_AXI_AXILITES_ADDR_WIDTH,
        C_S_AXI_DATA_WIDTH => C_S_AXI_AXILITES_DATA_WIDTH)
    port map (
        AWVALID => s_axi_AXILiteS_AWVALID,
        AWREADY => s_axi_AXILiteS_AWREADY,
        AWADDR => s_axi_AXILiteS_AWADDR,
        WVALID => s_axi_AXILiteS_WVALID,
        WREADY => s_axi_AXILiteS_WREADY,
        WDATA => s_axi_AXILiteS_WDATA,
        WSTRB => s_axi_AXILiteS_WSTRB,
        ARVALID => s_axi_AXILiteS_ARVALID,
        ARREADY => s_axi_AXILiteS_ARREADY,
        ARADDR => s_axi_AXILiteS_ARADDR,
        RVALID => s_axi_AXILiteS_RVALID,
        RREADY => s_axi_AXILiteS_RREADY,
        RDATA => s_axi_AXILiteS_RDATA,
        RRESP => s_axi_AXILiteS_RRESP,
        BVALID => s_axi_AXILiteS_BVALID,
        BREADY => s_axi_AXILiteS_BREADY,
        BRESP => s_axi_AXILiteS_BRESP,
        ACLK => ap_clk,
        ARESET => ap_rst_n_inv,
        ACLK_EN => ap_const_logic_1,
        ap_start => ap_start,
        interrupt => interrupt,
        ap_ready => ap_ready,
        ap_done => ap_done,
        ap_idle => ap_idle,
        rows_in => rows_in,
        cols_in => cols_in,
        rows_out => rows_out,
        cols_out => cols_out);

    Block_Mat_exit7_proc_U0 : component Block_Mat_exit7_proc
    port map (
        ap_clk => ap_clk,
        ap_rst => ap_rst_n_inv,
        ap_start => Block_Mat_exit7_proc_U0_ap_start,
        start_full_n => start_for_resize_U0_full_n,
        ap_done => Block_Mat_exit7_proc_U0_ap_done,
        ap_continue => Block_Mat_exit7_proc_U0_ap_continue,
        ap_idle => Block_Mat_exit7_proc_U0_ap_idle,
        ap_ready => Block_Mat_exit7_proc_U0_ap_ready,
        start_out => Block_Mat_exit7_proc_U0_start_out,
        start_write => Block_Mat_exit7_proc_U0_start_write,
        rows_in => rows_in,
        cols_in => cols_in,
        rows_out => rows_out,
        cols_out => cols_out,
        in_mat_rows_out_din => Block_Mat_exit7_proc_U0_in_mat_rows_out_din,
        in_mat_rows_out_full_n => in_mat_rows_c_full_n,
        in_mat_rows_out_write => Block_Mat_exit7_proc_U0_in_mat_rows_out_write,
        in_mat_cols_out_din => Block_Mat_exit7_proc_U0_in_mat_cols_out_din,
        in_mat_cols_out_full_n => in_mat_cols_c_full_n,
        in_mat_cols_out_write => Block_Mat_exit7_proc_U0_in_mat_cols_out_write,
        out_mat_rows_out_din => Block_Mat_exit7_proc_U0_out_mat_rows_out_din,
        out_mat_rows_out_full_n => out_mat_rows_c_full_n,
        out_mat_rows_out_write => Block_Mat_exit7_proc_U0_out_mat_rows_out_write,
        out_mat_cols_out_din => Block_Mat_exit7_proc_U0_out_mat_cols_out_din,
        out_mat_cols_out_full_n => out_mat_cols_c_full_n,
        out_mat_cols_out_write => Block_Mat_exit7_proc_U0_out_mat_cols_out_write);

    AXIvideo2xfMat_U0 : component AXIvideo2xfMat
    port map (
        ap_clk => ap_clk,
        ap_rst => ap_rst_n_inv,
        ap_start => AXIvideo2xfMat_U0_ap_start,
        ap_done => AXIvideo2xfMat_U0_ap_done,
        ap_continue => AXIvideo2xfMat_U0_ap_continue,
        ap_idle => AXIvideo2xfMat_U0_ap_idle,
        ap_ready => AXIvideo2xfMat_U0_ap_ready,
        srcPtr_TDATA => srcPtr_TDATA,
        srcPtr_TVALID => srcPtr_TVALID,
        srcPtr_TREADY => AXIvideo2xfMat_U0_srcPtr_TREADY,
        srcPtr_TKEEP => srcPtr_TKEEP,
        srcPtr_TSTRB => srcPtr_TSTRB,
        srcPtr_TUSER => srcPtr_TUSER,
        srcPtr_TLAST => srcPtr_TLAST,
        srcPtr_TID => srcPtr_TID,
        srcPtr_TDEST => srcPtr_TDEST,
        img_rows_dout => in_mat_rows_c_dout,
        img_rows_empty_n => in_mat_rows_c_empty_n,
        img_rows_read => AXIvideo2xfMat_U0_img_rows_read,
        img_cols_dout => in_mat_cols_c_dout,
        img_cols_empty_n => in_mat_cols_c_empty_n,
        img_cols_read => AXIvideo2xfMat_U0_img_cols_read,
        img_data_V_V_din => AXIvideo2xfMat_U0_img_data_V_V_din,
        img_data_V_V_full_n => in_mat_data_V_V_full_n,
        img_data_V_V_write => AXIvideo2xfMat_U0_img_data_V_V_write,
        img_rows_out_din => AXIvideo2xfMat_U0_img_rows_out_din,
        img_rows_out_full_n => in_mat_rows_c15_full_n,
        img_rows_out_write => AXIvideo2xfMat_U0_img_rows_out_write,
        img_cols_out_din => AXIvideo2xfMat_U0_img_cols_out_din,
        img_cols_out_full_n => in_mat_cols_c16_full_n,
        img_cols_out_write => AXIvideo2xfMat_U0_img_cols_out_write);

    resize_U0 : component resize
    port map (
        ap_clk => ap_clk,
        ap_rst => ap_rst_n_inv,
        ap_start => resize_U0_ap_start,
        start_full_n => start_for_xfMat2AXIvideo_U0_full_n,
        ap_done => resize_U0_ap_done,
        ap_continue => resize_U0_ap_continue,
        ap_idle => resize_U0_ap_idle,
        ap_ready => resize_U0_ap_ready,
        start_out => resize_U0_start_out,
        start_write => resize_U0_start_write,
        p_src_rows_dout => in_mat_rows_c15_dout,
        p_src_rows_empty_n => in_mat_rows_c15_empty_n,
        p_src_rows_read => resize_U0_p_src_rows_read,
        p_src_cols_dout => in_mat_cols_c16_dout,
        p_src_cols_empty_n => in_mat_cols_c16_empty_n,
        p_src_cols_read => resize_U0_p_src_cols_read,
        p_src_data_V_V_dout => in_mat_data_V_V_dout,
        p_src_data_V_V_empty_n => in_mat_data_V_V_empty_n,
        p_src_data_V_V_read => resize_U0_p_src_data_V_V_read,
        p_dst_rows_dout => out_mat_rows_c_dout,
        p_dst_rows_empty_n => out_mat_rows_c_empty_n,
        p_dst_rows_read => resize_U0_p_dst_rows_read,
        p_dst_cols_dout => out_mat_cols_c_dout,
        p_dst_cols_empty_n => out_mat_cols_c_empty_n,
        p_dst_cols_read => resize_U0_p_dst_cols_read,
        p_dst_data_V_V_din => resize_U0_p_dst_data_V_V_din,
        p_dst_data_V_V_full_n => out_mat_data_V_V_full_n,
        p_dst_data_V_V_write => resize_U0_p_dst_data_V_V_write,
        p_dst_rows_out_din => resize_U0_p_dst_rows_out_din,
        p_dst_rows_out_full_n => out_mat_rows_c17_full_n,
        p_dst_rows_out_write => resize_U0_p_dst_rows_out_write,
        p_dst_cols_out_din => resize_U0_p_dst_cols_out_din,
        p_dst_cols_out_full_n => out_mat_cols_c18_full_n,
        p_dst_cols_out_write => resize_U0_p_dst_cols_out_write);

    xfMat2AXIvideo_U0 : component xfMat2AXIvideo
    port map (
        ap_clk => ap_clk,
        ap_rst => ap_rst_n_inv,
        ap_start => xfMat2AXIvideo_U0_ap_start,
        ap_done => xfMat2AXIvideo_U0_ap_done,
        ap_continue => xfMat2AXIvideo_U0_ap_continue,
        ap_idle => xfMat2AXIvideo_U0_ap_idle,
        ap_ready => xfMat2AXIvideo_U0_ap_ready,
        img_rows_dout => out_mat_rows_c17_dout,
        img_rows_empty_n => out_mat_rows_c17_empty_n,
        img_rows_read => xfMat2AXIvideo_U0_img_rows_read,
        img_cols_dout => out_mat_cols_c18_dout,
        img_cols_empty_n => out_mat_cols_c18_empty_n,
        img_cols_read => xfMat2AXIvideo_U0_img_cols_read,
        img_data_V_V_dout => out_mat_data_V_V_dout,
        img_data_V_V_empty_n => out_mat_data_V_V_empty_n,
        img_data_V_V_read => xfMat2AXIvideo_U0_img_data_V_V_read,
        dstPtr_TDATA => xfMat2AXIvideo_U0_dstPtr_TDATA,
        dstPtr_TVALID => xfMat2AXIvideo_U0_dstPtr_TVALID,
        dstPtr_TREADY => dstPtr_TREADY,
        dstPtr_TKEEP => xfMat2AXIvideo_U0_dstPtr_TKEEP,
        dstPtr_TSTRB => xfMat2AXIvideo_U0_dstPtr_TSTRB,
        dstPtr_TUSER => xfMat2AXIvideo_U0_dstPtr_TUSER,
        dstPtr_TLAST => xfMat2AXIvideo_U0_dstPtr_TLAST,
        dstPtr_TID => xfMat2AXIvideo_U0_dstPtr_TID,
        dstPtr_TDEST => xfMat2AXIvideo_U0_dstPtr_TDEST);

    in_mat_rows_c_U : component fifo_w32_d2_A
    port map (
        clk => ap_clk,
        reset => ap_rst_n_inv,
        if_read_ce => ap_const_logic_1,
        if_write_ce => ap_const_logic_1,
        if_din => Block_Mat_exit7_proc_U0_in_mat_rows_out_din,
        if_full_n => in_mat_rows_c_full_n,
        if_write => Block_Mat_exit7_proc_U0_in_mat_rows_out_write,
        if_dout => in_mat_rows_c_dout,
        if_empty_n => in_mat_rows_c_empty_n,
        if_read => AXIvideo2xfMat_U0_img_rows_read);

    in_mat_cols_c_U : component fifo_w32_d2_A
    port map (
        clk => ap_clk,
        reset => ap_rst_n_inv,
        if_read_ce => ap_const_logic_1,
        if_write_ce => ap_const_logic_1,
        if_din => Block_Mat_exit7_proc_U0_in_mat_cols_out_din,
        if_full_n => in_mat_cols_c_full_n,
        if_write => Block_Mat_exit7_proc_U0_in_mat_cols_out_write,
        if_dout => in_mat_cols_c_dout,
        if_empty_n => in_mat_cols_c_empty_n,
        if_read => AXIvideo2xfMat_U0_img_cols_read);

    out_mat_rows_c_U : component fifo_w32_d3_A
    port map (
        clk => ap_clk,
        reset => ap_rst_n_inv,
        if_read_ce => ap_const_logic_1,
        if_write_ce => ap_const_logic_1,
        if_din => Block_Mat_exit7_proc_U0_out_mat_rows_out_din,
        if_full_n => out_mat_rows_c_full_n,
        if_write => Block_Mat_exit7_proc_U0_out_mat_rows_out_write,
        if_dout => out_mat_rows_c_dout,
        if_empty_n => out_mat_rows_c_empty_n,
        if_read => resize_U0_p_dst_rows_read);

    out_mat_cols_c_U : component fifo_w32_d3_A
    port map (
        clk => ap_clk,
        reset => ap_rst_n_inv,
        if_read_ce => ap_const_logic_1,
        if_write_ce => ap_const_logic_1,
        if_din => Block_Mat_exit7_proc_U0_out_mat_cols_out_din,
        if_full_n => out_mat_cols_c_full_n,
        if_write => Block_Mat_exit7_proc_U0_out_mat_cols_out_write,
        if_dout => out_mat_cols_c_dout,
        if_empty_n => out_mat_cols_c_empty_n,
        if_read => resize_U0_p_dst_cols_read);

    in_mat_data_V_V_U : component fifo_w24_d2_A
    port map (
        clk => ap_clk,
        reset => ap_rst_n_inv,
        if_read_ce => ap_const_logic_1,
        if_write_ce => ap_const_logic_1,
        if_din => AXIvideo2xfMat_U0_img_data_V_V_din,
        if_full_n => in_mat_data_V_V_full_n,
        if_write => AXIvideo2xfMat_U0_img_data_V_V_write,
        if_dout => in_mat_data_V_V_dout,
        if_empty_n => in_mat_data_V_V_empty_n,
        if_read => resize_U0_p_src_data_V_V_read);

    in_mat_rows_c15_U : component fifo_w32_d2_A
    port map (
        clk => ap_clk,
        reset => ap_rst_n_inv,
        if_read_ce => ap_const_logic_1,
        if_write_ce => ap_const_logic_1,
        if_din => AXIvideo2xfMat_U0_img_rows_out_din,
        if_full_n => in_mat_rows_c15_full_n,
        if_write => AXIvideo2xfMat_U0_img_rows_out_write,
        if_dout => in_mat_rows_c15_dout,
        if_empty_n => in_mat_rows_c15_empty_n,
        if_read => resize_U0_p_src_rows_read);

    in_mat_cols_c16_U : component fifo_w32_d2_A
    port map (
        clk => ap_clk,
        reset => ap_rst_n_inv,
        if_read_ce => ap_const_logic_1,
        if_write_ce => ap_const_logic_1,
        if_din => AXIvideo2xfMat_U0_img_cols_out_din,
        if_full_n => in_mat_cols_c16_full_n,
        if_write => AXIvideo2xfMat_U0_img_cols_out_write,
        if_dout => in_mat_cols_c16_dout,
        if_empty_n => in_mat_cols_c16_empty_n,
        if_read => resize_U0_p_src_cols_read);

    out_mat_data_V_V_U : component fifo_w24_d2_A
    port map (
        clk => ap_clk,
        reset => ap_rst_n_inv,
        if_read_ce => ap_const_logic_1,
        if_write_ce => ap_const_logic_1,
        if_din => resize_U0_p_dst_data_V_V_din,
        if_full_n => out_mat_data_V_V_full_n,
        if_write => resize_U0_p_dst_data_V_V_write,
        if_dout => out_mat_data_V_V_dout,
        if_empty_n => out_mat_data_V_V_empty_n,
        if_read => xfMat2AXIvideo_U0_img_data_V_V_read);

    out_mat_rows_c17_U : component fifo_w32_d2_A
    port map (
        clk => ap_clk,
        reset => ap_rst_n_inv,
        if_read_ce => ap_const_logic_1,
        if_write_ce => ap_const_logic_1,
        if_din => resize_U0_p_dst_rows_out_din,
        if_full_n => out_mat_rows_c17_full_n,
        if_write => resize_U0_p_dst_rows_out_write,
        if_dout => out_mat_rows_c17_dout,
        if_empty_n => out_mat_rows_c17_empty_n,
        if_read => xfMat2AXIvideo_U0_img_rows_read);

    out_mat_cols_c18_U : component fifo_w32_d2_A
    port map (
        clk => ap_clk,
        reset => ap_rst_n_inv,
        if_read_ce => ap_const_logic_1,
        if_write_ce => ap_const_logic_1,
        if_din => resize_U0_p_dst_cols_out_din,
        if_full_n => out_mat_cols_c18_full_n,
        if_write => resize_U0_p_dst_cols_out_write,
        if_dout => out_mat_cols_c18_dout,
        if_empty_n => out_mat_cols_c18_empty_n,
        if_read => xfMat2AXIvideo_U0_img_cols_read);

    start_for_resize_U0_U : component start_for_resize_U0
    port map (
        clk => ap_clk,
        reset => ap_rst_n_inv,
        if_read_ce => ap_const_logic_1,
        if_write_ce => ap_const_logic_1,
        if_din => start_for_resize_U0_din,
        if_full_n => start_for_resize_U0_full_n,
        if_write => Block_Mat_exit7_proc_U0_start_write,
        if_dout => start_for_resize_U0_dout,
        if_empty_n => start_for_resize_U0_empty_n,
        if_read => resize_U0_ap_ready);

    start_for_xfMat2AlbW_U : component start_for_xfMat2AlbW
    port map (
        clk => ap_clk,
        reset => ap_rst_n_inv,
        if_read_ce => ap_const_logic_1,
        if_write_ce => ap_const_logic_1,
        if_din => start_for_xfMat2AXIvideo_U0_din,
        if_full_n => start_for_xfMat2AXIvideo_U0_full_n,
        if_write => resize_U0_start_write,
        if_dout => start_for_xfMat2AXIvideo_U0_dout,
        if_empty_n => start_for_xfMat2AXIvideo_U0_empty_n,
        if_read => xfMat2AXIvideo_U0_ap_ready);





    ap_sync_reg_AXIvideo2xfMat_U0_ap_ready_assign_proc : process(ap_clk)
    begin
        if (ap_clk'event and ap_clk =  '1') then
            if (ap_rst_n_inv = '1') then
                ap_sync_reg_AXIvideo2xfMat_U0_ap_ready <= ap_const_logic_0;
            else
                if (((ap_sync_ready and ap_start) = ap_const_logic_1)) then 
                    ap_sync_reg_AXIvideo2xfMat_U0_ap_ready <= ap_const_logic_0;
                else 
                    ap_sync_reg_AXIvideo2xfMat_U0_ap_ready <= ap_sync_AXIvideo2xfMat_U0_ap_ready;
                end if; 
            end if;
        end if;
    end process;


    ap_sync_reg_Block_Mat_exit7_proc_U0_ap_ready_assign_proc : process(ap_clk)
    begin
        if (ap_clk'event and ap_clk =  '1') then
            if (ap_rst_n_inv = '1') then
                ap_sync_reg_Block_Mat_exit7_proc_U0_ap_ready <= ap_const_logic_0;
            else
                if (((ap_sync_ready and ap_start) = ap_const_logic_1)) then 
                    ap_sync_reg_Block_Mat_exit7_proc_U0_ap_ready <= ap_const_logic_0;
                else 
                    ap_sync_reg_Block_Mat_exit7_proc_U0_ap_ready <= ap_sync_Block_Mat_exit7_proc_U0_ap_ready;
                end if; 
            end if;
        end if;
    end process;


    AXIvideo2xfMat_U0_ap_ready_count_assign_proc : process (ap_clk)
    begin
        if (ap_clk'event and ap_clk = '1') then
            if (((ap_const_logic_0 = AXIvideo2xfMat_U0_ap_ready) and (ap_sync_ready = ap_const_logic_1))) then 
                AXIvideo2xfMat_U0_ap_ready_count <= std_logic_vector(unsigned(AXIvideo2xfMat_U0_ap_ready_count) - unsigned(ap_const_lv2_1));
            elsif (((ap_const_logic_1 = AXIvideo2xfMat_U0_ap_ready) and (ap_sync_ready = ap_const_logic_0))) then 
                AXIvideo2xfMat_U0_ap_ready_count <= std_logic_vector(unsigned(AXIvideo2xfMat_U0_ap_ready_count) + unsigned(ap_const_lv2_1));
            end if; 
        end if;
    end process;

    Block_Mat_exit7_proc_U0_ap_ready_count_assign_proc : process (ap_clk)
    begin
        if (ap_clk'event and ap_clk = '1') then
            if (((ap_const_logic_0 = Block_Mat_exit7_proc_U0_ap_ready) and (ap_sync_ready = ap_const_logic_1))) then 
                Block_Mat_exit7_proc_U0_ap_ready_count <= std_logic_vector(unsigned(Block_Mat_exit7_proc_U0_ap_ready_count) - unsigned(ap_const_lv2_1));
            elsif (((ap_const_logic_1 = Block_Mat_exit7_proc_U0_ap_ready) and (ap_sync_ready = ap_const_logic_0))) then 
                Block_Mat_exit7_proc_U0_ap_ready_count <= std_logic_vector(unsigned(Block_Mat_exit7_proc_U0_ap_ready_count) + unsigned(ap_const_lv2_1));
            end if; 
        end if;
    end process;
    AXIvideo2xfMat_U0_ap_continue <= ap_const_logic_1;
    AXIvideo2xfMat_U0_ap_start <= ((ap_sync_reg_AXIvideo2xfMat_U0_ap_ready xor ap_const_logic_1) and ap_start);
    AXIvideo2xfMat_U0_start_full_n <= ap_const_logic_1;
    AXIvideo2xfMat_U0_start_write <= ap_const_logic_0;
    Block_Mat_exit7_proc_U0_ap_continue <= ap_const_logic_1;
    Block_Mat_exit7_proc_U0_ap_start <= ((ap_sync_reg_Block_Mat_exit7_proc_U0_ap_ready xor ap_const_logic_1) and ap_start);
    ap_done <= xfMat2AXIvideo_U0_ap_done;
    ap_idle <= (xfMat2AXIvideo_U0_ap_idle and resize_U0_ap_idle and Block_Mat_exit7_proc_U0_ap_idle and AXIvideo2xfMat_U0_ap_idle);
    ap_ready <= ap_sync_ready;

    ap_rst_n_inv_assign_proc : process(ap_rst_n)
    begin
                ap_rst_n_inv <= not(ap_rst_n);
    end process;

    ap_sync_AXIvideo2xfMat_U0_ap_ready <= (ap_sync_reg_AXIvideo2xfMat_U0_ap_ready or AXIvideo2xfMat_U0_ap_ready);
    ap_sync_Block_Mat_exit7_proc_U0_ap_ready <= (ap_sync_reg_Block_Mat_exit7_proc_U0_ap_ready or Block_Mat_exit7_proc_U0_ap_ready);
    ap_sync_continue <= ap_const_logic_1;
    ap_sync_done <= xfMat2AXIvideo_U0_ap_done;
    ap_sync_ready <= (ap_sync_Block_Mat_exit7_proc_U0_ap_ready and ap_sync_AXIvideo2xfMat_U0_ap_ready);
    dstPtr_TDATA <= xfMat2AXIvideo_U0_dstPtr_TDATA;
    dstPtr_TDEST <= xfMat2AXIvideo_U0_dstPtr_TDEST;
    dstPtr_TID <= xfMat2AXIvideo_U0_dstPtr_TID;
    dstPtr_TKEEP <= xfMat2AXIvideo_U0_dstPtr_TKEEP;
    dstPtr_TLAST <= xfMat2AXIvideo_U0_dstPtr_TLAST;
    dstPtr_TSTRB <= xfMat2AXIvideo_U0_dstPtr_TSTRB;
    dstPtr_TUSER <= xfMat2AXIvideo_U0_dstPtr_TUSER;
    dstPtr_TVALID <= xfMat2AXIvideo_U0_dstPtr_TVALID;
    resize_U0_ap_continue <= ap_const_logic_1;
    resize_U0_ap_start <= start_for_resize_U0_empty_n;
    srcPtr_TREADY <= AXIvideo2xfMat_U0_srcPtr_TREADY;
    start_for_resize_U0_din <= (0=>ap_const_logic_1, others=>'-');
    start_for_xfMat2AXIvideo_U0_din <= (0=>ap_const_logic_1, others=>'-');
    xfMat2AXIvideo_U0_ap_continue <= ap_const_logic_1;
    xfMat2AXIvideo_U0_ap_start <= start_for_xfMat2AXIvideo_U0_empty_n;
    xfMat2AXIvideo_U0_start_full_n <= ap_const_logic_1;
    xfMat2AXIvideo_U0_start_write <= ap_const_logic_0;
end behav;
